// see if we can ever end up in binary search with hi<lo


class tester {

	static int [] A;
	static int MAX = 6;

	public static void main(String[] args) {
	    for (int i=1; i<10; i++) {
		    testrun(i);
	    }
	}

	public static void testrun(int MAX) {
	    A = new int[MAX+1];
	    int i;
	    for (i = 0; i<=MAX; i++) A[i] = 2*i;
	    boolean found=false;
	    for (i=0; i<MAX; i++) {
		if (search(2*i+1)) found=true;
	    }
	    if (found) 
	    System.out.println("success for " + MAX);
	    else
		System.out.println("failed for " + MAX);
	}


    public static boolean search(int X) {
	int lo=0; int hi=A.length - 1; int mid;
	while (lo < hi) {
	   mid = (lo+hi)/2;
	   if (X<A[mid]) hi = mid-1;        // search A[lo]...A[mid-1]
	   else if (X>A[mid]) lo=mid+1;      // search A[mid+1]...A[hi]
	   else lo = hi = mid;              // found
	}
	if (hi<lo) {
		System.out.format("ended search for %d with lo=%d, hi=%d%n", X, lo, hi);
		return true;
	}
	return false;
    }
}